extern vec2  iResolution;
extern float iGlobalTime;
extern float Iterations;
extern float Zoom;
extern vec2  Pan;

const float MaxIterations = 1024.;

const float Bound = 256.;

vec2 Scale(vec2 p){
	return (p*2.-iResolution.xy)/iResolution.y*1.5;
}

vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords ){
	vec2 z = vec2(0);
	vec2 c = Scale(screen_coords)*Zoom+Pan;

	float n = 0;
	for (float i=0.;i<MaxIterations;i++){
		z = vec2(z.x*z.x-z.y*z.y,2.*z.x*z.y)+c;  
		if( dot(z,z)>Bound*Bound || i>Iterations) break;
		n++;
	}
	
	float sn = n-log(log(length(z))/log(Bound))/log(2.0);
	
    return vec4(0.5 + 0.5*cos( 3.0 + sn*0.15 + vec3(0.0,0.6,1.0)),1);
}